/*
  This file is part of KMail, the KDE mail client.
  Copyright (c) 2009 Sebastian Trueg <trueg@kde.org>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along
  with this program; if not, write to the Free Software Foundation, Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
*/

#ifndef _KMAIL_ANNOTATION_WIDGET_H_
#define _KMAIL_ANNOTATION_WIDGET_H_

#include <QtGui/QWidget>

#include <Nepomuk/Resource>

namespace Nepomuk {
    class ResourceAnnotationModel;
    class AnnotationRelevanceFilterModel;
    class Annotation;
}
class QListView;
class QModelIndex;

class AnnotationWidget : public QWidget
{
    Q_OBJECT

public:
    AnnotationWidget( QWidget* parent = 0 );
    ~AnnotationWidget();

    void setResource( const Nepomuk::Resource& res, const QString& content );

protected:
  //virtual QSize sizeHint() const { return QSize(200, 300); }

Q_SIGNALS:
    void newAnnotation( Nepomuk::Annotation* );
    void annotationCreated();

private Q_SLOTS:
    void slotAnnotationExecuted( const QModelIndex& );

private:
    Nepomuk::ResourceAnnotationModel* m_model;
    Nepomuk::AnnotationRelevanceFilterModel* m_filterModel;
    QListView* m_listView;
};

#endif
